module Demo (
                      demoData,
                      ReplayInfo(..)
                     ) where

-- | Demos are automatically played if you let the title scene run for a minute.
newtype ReplayInfo = ReplayInfo ((Int,Int),String)
                  deriving (Show,Read)

-- | Infinite list of demos.
demoData :: [ReplayInfo]
demoData = map ReplayInfo $ cycle [d1,d2,d3,d4,d5,d6,dieIn5,laserFool,shieldAttack,three]

{- import Control.Arrow ((&&&))
   import Data.List (group)

   --| Take a bunch of Ints, and run-length encode them - first member of a pair specifies how many, second what.
   rleEncode :: [Int] -> [(Int, Int)]
   rleEncode = map (length &&& head) . group -}

{- | Take a bunch of Int pairs, undo the run-length encoding, and then turn
   the resulting [Int] into a String. The pairs are a run-length encoding of a String;
   this was an inadvertent re-implementation of Don Stewart's RLE <http://cgi.cse.unsw.edu.au/~dons/blog/2007/07>. -}
rleDecode :: [(Int, Int)] -> String
rleDecode = show . (uncurry replicate =<<)

-- | Data specifying the demo.
d1,d2,d3,d4,d5,d6,dieIn5,laserFool,shieldAttack,three :: ((Int, Int), String)
d1 = ((2,1),d)
     where d = rleDecode [(5, 3), (10, 67), (6, 3), (5, 67), (29, 3), (2, 11), (29, 3), (5, 35), (3, 3), (3, 35), (24, 3), (2, 35), (19, 3), (7, 19), (21, 51), (63, 35), (15, 43), (5, 11), (8, 43), (8, 35), (3, 3), (9, 35), (20, 3), (52, 67), (32, 3), (13, 35), (3, 3), (11, 35), (5, 3), (9, 35), (4, 3), (6, 35), (4, 3), (5, 35), (13, 3), (14, 19), (4, 3), (4, 19), (6, 3), (4, 19), (7, 3), (5, 19), (8, 3), (8, 19), (5, 83), (3, 67), (2, 3), (12, 19), (5, 83), (17, 19), (9, 83), (2, 19), (5, 3), (20, 67), (1, 75), (38, 11), (1, 43), (4, 35), (7, 3), (57, 67), (2, 3), (5, 19), (17, 3), (6, 19), (8, 3), (6, 67), (7, 83), (59, 3), (9, 19), (1, 51), (17, 35), (20, 3), (14, 35), (7, 3), (2, 35), (11, 43), (6, 11), (7, 3), (26, 67), (7, 3), (13, 35), (5, 43), (7, 11), (2, 3), (5, 67), (1, 83), (2, 19), (2, 3), (10, 67), (21, 3), (147, 0)]

d2 = ((2,2),d)
     where d = rleDecode [(10, 0), (3, 8), (13, 9), (98, 73), (29, 65), (45, 1), (12, 17), (6, 1), (19, 17), (1, 81), (14, 65), (1, 81), (2, 17), (8, 21), (15, 17), (12, 49), (20, 17), (17, 49), (1, 25), (9, 9), (8, 73), (11, 65), (2, 81), (3, 17), (6, 21), (4, 17), (1, 49), (8, 33), (12, 1), (15, 65), (16, 33), (2, 1), (7, 65), (13, 33), (2, 41), (30, 9), (13, 41), (14, 9), (7, 1), (3, 33), (5, 1), (3, 9), (9, 1), (5, 33), (5, 1), (14, 33), (8, 1), (8, 65), (5, 1), (6, 33), (5, 1), (4, 33), (3, 1), (2, 33), (20, 1), (1, 33), (5, 1), (4, 33), (3, 1), (7, 33), (3, 49), (8, 17), (14, 49), (35, 17), (8, 1), (2, 17), (15, 1), (5, 33), (5, 1), (6, 65), (10, 1), (3, 33), (5, 1), (2, 33), (2, 1), (27, 65), (5, 1), (10, 65), (3, 73), (2, 65), (6, 1), (4, 65), (11, 1), (19, 9), (1, 41), (17, 33), (2, 41), (5, 9), (3, 1), (2, 17), (1, 1), (7, 17), (11, 49), (2, 17), (11, 1), (2, 33), (4, 1), (3, 33), (3, 1), (2, 33), (4, 1), (1, 33), (4, 1), (3, 33), (5, 1), (3, 33), (2, 1), (8, 9), (1, 73), (8, 65), (7, 73), (4, 65), (5, 73), (5, 1), (5, 65), (6, 1), (36, 65), (5, 73), (2, 9), (5, 13), (5, 9), (1, 1), (7, 3), (2, 35), (4, 43), (15, 35), (6, 43), (26, 35), (9, 43), (16, 35), (18, 3), (12, 67), (3, 75), (1, 67), (7, 3), (6, 67), (2, 3), (15, 19), (8, 83), (7, 67), (7, 83), (4, 67), (9, 3), (4, 67), (1, 83), (9, 19), (1, 83), (8, 67), (1, 3), (13, 19), (1, 83), (3, 67), (14, 3), (8, 35), (1, 43), (5, 11), (10, 3), (5, 11), (3, 3), (3, 11), (24, 3), (1, 19), (40, 3), (5, 67), (8, 3), (4, 67), (5, 19), (11, 3), (10, 35), (1, 43), (2, 11), (11, 3), (5, 35), (6, 3), (4, 35), (24, 3), (8, 67), (6, 3), (5, 35), (4, 3), (4, 35), (22, 3), (1, 11), (31, 3), (1, 11), (32, 3), (3, 67), (10, 3), (5, 35), (2, 3), (10, 35), (5, 3), (6, 35), (5, 3), (3, 35), (5, 3), (2, 35), (5, 3), (2, 35), (6, 3), (2, 35), (10, 3), (8, 67), (9, 3), (7, 67), (5, 3), (3, 67), (4, 3), (17, 67), (5, 3), (2, 11), (5, 3), (14, 67), (5, 3), (3, 67), (7, 3), (5, 67), (8, 3), (3, 67), (8, 3), (15, 35), (6, 3), (31, 67), (4, 3), (10, 67), (6, 19), (2, 3), (2, 67), (1, 83), (10, 19), (4, 51), (19, 35), (5, 3), (3, 35), (4, 3), (1, 35), (16, 3), (4, 35), (3, 3), (2, 35), (5, 3), (1, 35), (11, 3), (2, 19), (9, 3), (1, 67), (2, 83), (5, 67), (4, 3), (5, 67), (3, 3), (18, 35), (5, 3), (3, 35), (5, 3), (2, 35), (5, 3), (3, 35), (3, 3), (4, 35), (11, 3), (2, 35), (13, 3), (3, 35), (12, 3), (2, 35), (11, 3), (2, 35), (15, 3), (3, 11), (9, 3), (1, 35), (8, 3), (1, 35), (6, 3), (4, 35), (14, 3), (2, 35), (5, 3), (3, 35), (23, 3), (1, 35), (12, 3), (3, 35), (13, 3), (3, 35), (15, 3), (3, 11), (7, 3), (3, 35), (11, 3), (2, 35), (5, 3), (3, 35), (25, 3), (2, 1), (155, 0)]

d3 = ((1,2),d)
     where d = rleDecode [(13, 0), (2, 8), (16, 9), (77, 73), (25, 65), (5, 1), (3, 9), (15, 1), (5, 65), (15, 1), (4, 65), (13, 1), (5, 65), (10, 1), (5, 17), (2, 1), (6, 65), (1, 1), (16, 17), (2, 1), (9, 65), (1, 1), (5, 17), (4, 21), (13, 17), (16, 49), (29, 17), (4, 49), (2, 33), (2, 41), (6, 9), (4, 73), (11, 65), (1, 1), (16, 17), (5, 1), (3, 17), (7, 1), (6, 33), (5, 1), (3, 33), (4, 1), (8, 65), (10, 1), (4, 33), (7, 1), (2, 33), (1, 1), (8, 65), (26, 33), (3, 41), (31, 9), (13, 41), (21, 9), (11, 41), (19, 9), (4, 1), (5, 33), (8, 1), (48, 65), (1, 97), (2, 33), (4, 1), (13, 33), (1, 49), (24, 17), (12, 49), (41, 17), (6, 1), (5, 9), (11, 73), (3, 9), (1, 73), (8, 65), (1, 73), (32, 9), (9, 41), (15, 9), (6, 41), (3, 33), (4, 1), (13, 65), (1, 97), (4, 33), (28, 49), (19, 33), (11, 49), (5, 33), (16, 49), (4, 17), (5, 81), (13, 65), (7, 73), (16, 33), (9, 49), (2, 33), (2, 1), (1, 65), (1, 1), (4, 17), (1, 49), (6, 33), (1, 1), (4, 9), (5, 73), (66, 65), (2, 73), (13, 9), (6, 41), (13, 9), (6, 13), (4, 9), (6, 1), (3, 9), (10, 1), (21, 65), (16, 1), (4, 65), (6, 1), (3, 33), (10, 1), (3, 33), (10, 1), (3, 33), (6, 1), (1, 33), (13, 1), (1, 33), (10, 1), (4, 33), (11, 1), (4, 33), (5, 1), (1, 33), (12, 1), (3, 33), (10, 1), (2, 33), (11, 1), (5, 33), (8, 1), (3, 33), (8, 1), (2, 33), (8, 1), (3, 33), (15, 1), (2, 33), (5, 1), (3, 33), (5, 1), (45, 33), (20, 49), (27, 17), (42, 81), (6, 65), (6, 73), (26, 65), (8, 73), (27, 9), (35, 41), (11, 33), (4, 41), (18, 33), (2, 41), (2, 33), (1, 1), (4, 65), (8, 69), (6, 65), (7, 67), (14, 83), (23, 19), (18, 83), (4, 67), (11, 3), (4, 35), (1, 3), (7, 67), (5, 3), (2, 67), (16, 3), (4, 35), (4, 3), (8, 67), (5, 3), (11, 35), (5, 3), (2, 35), (3, 51), (7, 35), (13, 3), (5, 67), (5, 3), (3, 67), (13, 3), (5, 67), (5, 3), (3, 67), (5, 3), (27, 67), (1, 83), (8, 19), (25, 51), (25, 3), (5, 35), (18, 3), (1, 67), (6, 83), (3, 67), (22, 3), (32, 35), (5, 3), (5, 35), (1, 3), (7, 35), (7, 3), (4, 11), (5, 3), (4, 35), (5, 3), (3, 35), (3, 3), (4, 19), (16, 3), (1, 19), (14, 3), (8, 67), (8, 3), (4, 19), (1, 3), (15, 67), (2, 83), (11, 67), (2, 75), (1, 11), (6, 3), (1, 11), (16, 3), (5, 67), (5, 3), (3, 35), (5, 3), (3, 11), (4, 3), (5, 11), (11, 3), (9, 19), (8, 3), (2, 35), (18, 43), (22, 35), (12, 43), (20, 35), (27, 51), (1, 19), (7, 3), (2, 19), (7, 3), (13, 67), (5, 75), (5, 67), (1, 75), (5, 11), (5, 43), (2, 35), (7, 3), (4, 67), (12, 83), (10, 67), (5, 83), (23, 67), (3, 75), (24, 67), (2, 99), (3, 35), (7, 39), (1, 35), (2, 43), (5, 3), (11, 35), (1, 43), (1, 11), (5, 3), (5, 35), (3, 3), (6, 35), (4, 3), (11, 35), (5, 3), (3, 35), (5, 3), (10, 67), (38, 3), (2, 35),(121, 3), (1, 2), (49, 0)]

d4 = ((1,0),d)
     where d = rleDecode [(277, 0), (311, 7), (19, 71), (1, 87), (1, 84), (9, 80), (13, 16), (4, 80), (3, 64), (2, 72), (21, 8), (7, 40), (10, 32), (2, 48), (4, 32), (18, 48), (22, 16), (2, 48), (3, 32), (5, 48), (6, 32), (4, 40), (2, 8), (7, 72), (16, 64), (1, 96), (7, 32), (1, 40), (7, 8), (1, 72), (4, 64), (11, 0), (10, 8), (2, 40), (4, 8), (2, 40), (21, 32), (13, 48), (3, 16), (4, 80), (5, 64), (15, 72), (14, 64), (5, 80), (14, 16), (17, 48), (17, 32), (17, 40), (2, 8), (4, 72), (11, 64), (3, 80), (11, 16), (3, 80), (3, 64), (1, 72), (5, 8), (5, 40), (2, 8), (5, 72), (7, 64), (13, 72), (7, 8), (2, 40), (7, 32), (5, 48), (15, 16), (8, 80), (4, 64), (2, 72), (13, 8), (6, 0), (5, 8), (9, 0), (5, 32), (2, 48), (9, 16), (1, 80), (4, 64), (4, 8), (1, 0), (10, 32), (16, 0), (6, 32), (5, 40), (12, 8), (4, 72), (9, 64), (8, 80), (9, 16), (15, 48), (10, 32), (5, 96), (5, 64), (3, 72), (8, 8), (18, 72), (8, 64), (2, 80), (3, 16), (33, 48), (12, 16), (6, 80), (9, 64), (2, 72), (4, 8), (49, 40), (18, 8), (2, 72), (6, 64), (49, 80), (18, 16), (25, 0), (11, 32), (5, 40), (3, 8), (4, 72), (5, 64), (3, 72), (6, 64), (7, 80), (4, 64), (4, 72), (8, 8), (5, 40), (20, 32), (4, 40), (7, 8), (5, 72), (11, 64), (3, 80), (4, 16), (8, 48), (4, 32), (9, 48), (10, 32), (2, 96), (7, 64), (3, 80), (4, 16), (10, 0), (4, 8), (16, 0), (7, 32), (8, 0), (6, 32), (1, 40), (17, 8), (6, 64), (3, 0), (9, 32), (5, 16), (2, 80), (6, 64), (8, 72), (3, 8), (5, 40), (10, 32), (2, 40), (2, 8), (3, 72), (7, 64), (1, 80), (8, 16), (1, 0), (10, 64), (2, 80), (14, 16), (2, 48), (17, 32), (4, 40), (3, 8), (2, 72), (10, 64), (7, 80), (4, 16), (1, 0), (5, 64), (4, 72), (9, 8), (27, 64), (3, 96), (10, 32), (9, 40), (16, 32), (6, 48), (4, 16), (9, 80), (14, 64), (3, 80), (3, 48), (12, 32), (3, 40), (2, 8), (9, 72), (1, 8), (4, 40), (19, 32), (4, 48), (1, 16), (4, 80), (12, 64), (2, 0), (17, 32), (1, 40), (2, 8), (3, 72), (1, 64), (10, 0), (6, 8), (12, 0), (1, 64), (2, 80), (4, 16), (7, 80), (6, 16), (2, 80), (5, 64), (3, 72), (12, 8), (4, 40), (11, 32), (1, 0), (6, 64), (4, 0), (10, 32), (10, 48), (4, 32), (3, 40), (1, 8), (10, 72), (9, 64), (2, 80), (10, 16), (1, 80), (18, 64), (2, 0), (2, 8), (15, 32), (2, 48), (3, 16), (3, 80), (9, 64), (6, 80), (4, 16), (1, 0), (12, 64), (6, 72), (11, 8), (3, 40), (2, 32), (2, 96), (4, 64), (1, 0), (4, 32), (12, 40), (6, 32), (1, 48), (1, 112), (5, 80), (3, 64), (7, 80), (4, 48), (16, 32), (5, 40), (5, 8), (2, 40), (9, 32), (1, 96), (11, 64), (4, 80), (10, 16), (1, 48), (8, 32), (15, 0), (9, 16), (2, 0), (19, 64), (1, 96), (6, 32), (9, 0), (10, 64), (8, 72), (5, 64), (3, 80), (3, 16), (3, 80), (5, 64), (4, 72), (8, 8), (7, 72), (6, 64), (3, 80), (2, 16), (15, 48), (8, 32), (9, 40), (23, 32), (14, 40), (6, 8), (3, 0), (7, 32), (12, 48), (12, 16), (2, 80), (19, 64), (3, 72), (4, 64), (5, 72), (16, 64), (6, 72), (12, 8), (1, 40), (4, 32), (3, 96), (1, 64), (5, 80), (3, 16), (4, 80), (13, 64), (5, 80), (9, 16), (4, 48), (5, 32), (2, 40), (3, 72), (7, 64), (5, 80), (3, 16), (2, 48), (14, 32), (13, 40), (27, 32), (5, 40), (6, 32), (7, 48), (1, 16), (1, 80), (8, 64), (2, 0), (7, 32), (3, 48), (4, 16), (15, 0), (6, 32), (3, 40), (10, 8), (4, 72), (2, 8), (9, 0), (6, 32), (170, 0)]

d5 = ((2,0),d)
     where d = rleDecode [(20,0), (80,8), (13,0), (9,8), (77,0), (5,3), (3,3), (80,6), (2,8), (1,1), (5,2), (20,1), (1,1), (80,4), (11,4), (5,3), (3,1), (31,6), (15,6), (4,0), (40,3), (4,3), (33,0), (50,1), (15,0), (8,3), (17,0), (57,1), (16,6), (1,1), (6,9), (5,1), (3,9), (27,1), (2,3), (2,3), (3,4), (3,8), (1,9), (3,1), (4,9), (10,1), (5,9), (4,1), (3,9), (7,1), (3,9), (5,1), (2,9), (5,1), (11,9), (14,1), (8,6), (1,6), (19,8), (3,1), (28,4), (2,1), (7,8), (4,6), (63,6), (21,6), (2,7), (2,9), (7,4), (10,4), (15,8), (41,4), (5,3), (2,9), (26,6), (12,3), (7,3), (19,3), (3,4), (27,1), (19,4), (13,1), (3,4), (3,3), (26,1), (33,6), (17,7), (5,6), (1,9), (1,15), (8,4), (28,9), (10,4), (2,3), (6,3), (6,3), (2,4), (5,1), (3,8), (38,6), (1,6), (4,3), (7,3), (1,4), (5,4), (9,1), (1,4), (2,4), (5,3), (8,0), (2,1), (6,3), (1,0), (8,3), (14,4), (32,1), (24,0), (12,6), (2,7), (5,8), (7,0), (3,8), (5,0), (5,8), (64,0), (4,3), (6,4), (22,3), (5,4), (5,1), (2,8), (10,6), (20,8), (10,8), (6,8), (2,6), (3,1), (2,3), (5,3), (2,4), (1,1), (15,9), (12,1), (5,4), (2,1), (10,9), (8,4), (2,9), (6,1), (29,3), (19,1), (3,0), (15,3), (1,4), (2,8), (15,0), (12,3), (2,0), (2,6), (17,6), (23,1), (7,3), (38,1), (6,3), (39,1), (7,3), (27,1), (46,6), (1,6), (4,3), (4,1), (3,3), (5,1), (23,3), (3,4), (7,5), (12,4), (10,3), (17,4), (2,3), (3,3), (3,3), (5,1), (3,9), (1,4), (1,9), (10,1), (8,3), (2,1), (2,3), (5,1), (19,6), (21,8), (6,1), (2,1), (3,4), (20,3), (7,4), (4,3), (9,1), (4,3), (3,3), (3,3), (14,1), (23,6), (2,1), (4,1), (1,1), (6,3), (5,1), (7,1), (7,1), (5,6), (1,1), (5,1), (2,1), (7,3), (6,1), (22,9), (18,1), (7,6), (11,1), (3,4), (14,1), (1,1), (4,3), (35,1), (24,9), (6,4), (16,3), (4,4), (12,1), (30,1), (15,9), (3,4), (1,9), (14,1), (17,1), (2,1), (70,1), (5,1), (4,1), (7,3), (10,1), (4,6), (10,7), (30,6), (6,1), (5,6), (5,1), (4,1), (19,1), (24,6), (5,1), (5,6), (3,1), (5,6), (7,1), (3,6), (7,1), (2,6), (9,1), (53,3), (8,3), (6,3), (4,4), (16,9), (3,7), (3,9), (13,1), (3,9), (3,1), (7,3), (16,1), (17,6), (2,6), (5,3), (2,3), (6,1), (19,1), (7,8), (26,1), (6,1), (5,1), (1,3), (1,4), (5,5), (2,3), (19,3), (13,4), (1,4), (5,3), (2,4), (8,9), (2,7), (10,6), (14,1), (9,0), (5,4), (9,0), (5,8), (11,0), (3,8), (17,0), (5,1), (13,1), (32,1), (5,1), (2,6), (11,7), (19,6), (3,7), (39,9), (6,1), (17,3), (2,6), (10,6), (6,6), (5,3), (9,1), (4,3), (6,6), (4,3), (1,6), (5,6), (10,1), (2,6), (1,8), (3,1), (2,1), (7,1), (8,3), (3,1), (15,6), (3,6), (2,3), (3,1), (7,1), (2,4), (27,3), (6,3), (1,3), (11,4), (13,4), (4,4), (10,5), (5,4), (5,4), (5,1), (6,1), (16,0), (10,6), (1,7), (3,6), (4,7), (3,8), (6,0), (3,8), (18,0), (3,8), (3,0), (2,3), (8,3), (10,1), (15,9), (5,1), (14,9), (1,1), (5,3), (5,1), (2,3), (3,1), (2,9), (5,1), (3,9), (5,1), (2,9), (3,1), (10,3), (1,1), (4,3), (6,1), (11,3), (3,6), (4,6), (8,1), (2,1), (5,1), (1,5), (7,4), (21,1), (14,4), (6,5), (4,4), (8,1), (5,1), (7,6), (13,7), (4,9), (29,1), (12,9), (2,1), (2,3), (1,3), (4,4), (1,1), (1,9), (6,1), (3,9), (4,7), (15,6), (4,6), (4,6), (1,8), (2,1), (2,4), (3,3), (1,1), (1,6), (3,1), (12,9), (3,4), (9,3), (1,4), (4,9), (3,1), (5,9), (3,1), (2,9), (14,1), (6,3), (7,1), (5,5), (3,1), (2,9), (11,1), (43,6), (8,1), (1,6), (39,1), (19,3), (24,1), (2,3), (54,1), (19,3), (95,1), (15,3), (2,1), (18,3), (23,4), (6,1), (11,1), (3,8), (15,6), (3,6), (8,7), (1,7), (7,6), (9,6), (7,6), (8,7), (12,9), (3,4), (2,4), (3,3), (5,3), (8,4), (12,3), (2,1), (4,6), (8,6), (5,6), (17,1), (8,3), (3,6), (5,6), (8,1), (4,1), (1,1), (7,3), (3,6), (2,6), (19,1), (4,3), (7,6), (2,8), (1,8), (4,1), (11,1), (9,3), (11,3), (7,1), (3,1), (5,6), (2,1), (9,3), (6,1), (4,1), (2,1), (2,3), (2,4), (2,3), (8,1), (4,6), (2,1), (4,3), (4,6), (2,3), (10,1), (4,9), (9,1), (24,3), (2,4), (15,3), (4,4), (1,4), (10,1), (7,9), (2,3), (6,3), (13,1), (4,3), (3,6), (5,6), (2,8), (8,1), (7,8), (10,1), (1,1), (9,3), (5,1), (3,1), (11,1), (8,3), (4,1), (8,7), (5,6), (6,1), (4,1), (4,8), (10,6), (8,6), (11,6), (1,9), (29,3), (1,4), (2,4), (5,1), (1,7), (4,7), (10,6), (17,1), (33,3), (18,4), (3,9), (2,1), (3,4), (5,3), (8,1), (8,6), (9,6), (2,3), (19,1), (1,3), (8,6), (3,3), (2,1), (8,8), (2,1), (10,1), (9,3), (3,1), (7,1), (6,1), (8,3), (2,6), (5,6), (5,1), (5,3), (6,6), (2,6), (5,1), (2,6), (1,7), (2,9), (5,1), (5,9), (2,1), (4,6), (6,7), (6,6), (3,1), (1,3), (3,6), (6,3), (4,1), (4,3), (1,4), (1,1), (9,1), (3,1), (2,1), (1,3), (7,4), (7,1), (1,4), (2,3), (4,3), (2,5), (12,4), (5,3), (10,4), (5,3), (7,3), (1,3), (5,4), (2,9), (7,7), (7,6), (3,7), (10,9), (3,1), (5,3), (11,1), (4,9), (11,1), (3,9), (2,1), (3,3), (3,1), (2,3), (11,1), (8,3), (2,1), (11,1), (42,6), (14,1), (6,5), (10,1), (11,3), (33,1), (13,3), (7,1), (4,3), (13,3), (7,0), (5,3), (7,0), (1,3), (21,0), (3,3), (5,0), (3,3), (16,0), (18,1), (11,0), (7,3), (5,0), (1,3), (2,0), (6,1), (2,3), (6,2), (43,0), (3,3), (31,0), (3,3), (10,0), (11,3), (10,0), (15,1), (5,3), (2,6), (5,3), (5,6), (10,6), (2,6), (6,3), (3,6), (16,6), (6,8), (10,8), (7,1), (5,4), (10,5), (10,4), (13,5), (7,4), (12,1), (4,3), (3,3), (1,3), (6,1), (2,1), (5,8), (11,6), (5,1), (14,6), (5,7), (7,7), (3,7), (34,8), (5,4), (46,3), (19,4), (5,1), (11,8), (7,8), (3,8), (34,6), (15,7), (4,6), (9,8), (17,1), (3,8), (13,6), (11,7), (7,8), (6,4), (5,3), (51,4), (25,3), (24,4), (8,4), (3,1), (17,8), (11,6), (42,7), (10,6), (17,8), (4,1), (21,4), (10,1), (12,8), (11,6), (1,6), (6,7), (2,8), (2,0), (4,3), (2,0), (5,1), (10,0), (1,6), (16,7), (8,8), (26,4), (21,3), (4,4), (11,4), (8,4), (7,1), (5,8), (8,6), (5,6), (3,7), (4,6), (2,8), (10,8), (2,6), (3,7), (4,8), (3,7), (14,6), (2,8), (7,1), (1,8), (3,6), (7,0), (7,3), (1,4), (5,8), (10,7), (9,8), (25,4), (43,3), (13,4), (2,4), (9,1), (4,1), (11,8), (7,6), (20,7), (2,7), (11,6), (10,6), (16,8), (12,1), (3,8), (6,6), (4,7), (3,8), (2,0), (16,3), (2,4), (8,1), (8,4), (35,3), (7,4), (1,4), (9,9), (15,8), (9,7), (2,7), (5,6), (3,8), (25,8), (13,6), (4,7), (4,6), (12,7), (3,8), (4,0), (5,1), (5,0), (18,1), (3,4), (2,3), (13,0), (9,8), (8,0), (3,1), (1,8), (11,6), (2,0), (3,1), (15,0), (3,3), (4,4), (3,0), (11,6), (4,0), (5,1), (8,0), (4,1), (2,4), (42,3), (2,4), (6,4), (1,9), (20,8), (7,9), (3,7), (1,7), (3,6), (17,8), (4,6), (6,7), (2,6), (24,8), (7,6), (2,0), (4,8), (11,0), (10,1), (1,4), (27,3), (44,4), (3,8), (2,7), (5,6), (1,0), (6,1), (6,8), (1,1), (10,0), (7,4), (21,0), (4,3), (3,4), (13,1), (12,8), (4,6), (3,7), (2,8), (8,4), (8,8), (6,4), (2,3), (57,0), (19,8), (6,0), (3,8), (22,0), (40,6), (10,3), (24,4), (19,1), (2,4), (2,1), (29,0), (4,1), (9,0), (13,6), (5,7), (18,6), (2,0), (3,1), (7,0), (11,3), (29,4), (10,8), (19,4), (2,3), (8,3), (2,3), (6,0), (10,1), (6,8), (20,1), (12,8), (5,6), (10,0), (5,1), (7,0), (6,3), (2,4), (2,4), (6,9), (25,8), (40,0), (10,8), (5,0), (15,1), (15,0), (7,3), (5,4), (14,1), (4,0), (16,6), (1,8), (8,1), (18,4), (4,3), (4,4), (30,8), (1,9), (8,7), (5,7), (4,8), (3,0), (5,6), (1,0), (4,1), (3,0), (3,3), (2,4), (6,3), (6,4), (15,0), (13,6), (6,8), (6,1), (5,0), (22,1), (6,4), (6,1), (9,0), (10,1), (2,0), (5,3), (3,4), (3,8), (7,7), (15,8), (5,0), (2,3), (3,4), (2,3), (8,4), (12,8), (2,7), (4,6), (4,7), (2,6), (2,0), (5,8), (27,0), (11,1), (3,0), (9,1), (4,4), (9,1), (17,8), (16,1), (10,0), (3,3), (2,0), (7,1), (3,3), (2,3), (6,4), (28,8), (6,1), (3,8), (7,4), (5,4), (1,3), (4,4), (1,4), (3,1), (7,8), (23,1), (16,8), (10,6), (3,1), (2,3), (5,4), (5,4), (23,8), (20,7), (6,6), (2,8), (5,4), (27,4), (9,1), (6,8), (12,1), (1,8), (5,6), (5,7), (13,6), (2,0), (5,1), (8,0), (3,6), (51,0), (10,3), (10,4), (7,4), (15,9), (3,4), (10,9), (6,7), (2,9), (4,4), (3,9), (2,4), (8,3), (2,3), (4,5), (4,1), (6,1), (3,1), (1,3), (2,4), (6,1), (3,8), (17,1), (31,1), (2,0), (5,3), (3,0), (5,8), (3,0), (4,8), (1,9), (2,1), (2,3), (2,6), (3,7), (4,1), (2,9), (3,8), (1,7), (15,6), (7,8), (2,8), (8,5), (2,4), (13,4), (4,3), (5,2), (1,3), (10,3), (2,9), (8,1), (3,7), (2,6), (4,3), (3,1), (2,8), (8,0), (5,3), (3,0), (19,6), (2,6), (11,1), (10,0), (2,6), (6,0), (1,1), (8,3), (2,3), (13,3), (2,4), (11,8), (5,0), (2,8), (15,0), (1,8), (1,7), (3,6), (10,6), (10,1), (2,3), (5,1), (4,1), (1,1), (8,3), (5,1), (3,0), (3,1), (5,3), (4,1), (1,5), (12,3), (6,4), (18,9), (5,1), (3,9), (8,1), (2,3), (6,6), (10,6), (4,1), (17,3), (19,1), (2,6), (8,6), (20,6), (12,3), (14,1), (28,3), (1,3), (7,3), (2,1), (3,3), (10,1), (9,3), (6,1), (3,3), (6,1), (4,3), (9,1), (8,3), (2,4), (1,1), (21,1), (1,3), (6,6), (3,3), (3,1), (4,9), (22,1), (4,3), (6,6), (10,6), (1,8), (1,8), (7,1), (8,1), (7,1), (3,3), (5,1), (2,1), (1,1), (5,3), (4,1), (6,6), (2,1), (3,1), (18,1), (2,1), (4,8), (4,6), (4,6), (1,6), (3,1), (2,9), (3,8), (2,4), (23,3), (12,0), (6,8), (3,7), (1,7), (1,6), (4,8), (6,1), (1,1), (9,1), (6,0), (1,1), (2,3), (4,1), (7,3), (2,1), (22,0), (1,6), (4,7), (19,8), (1,4), (6,3), (4,4), (4,3), (3,4), (6,8), (1,4), (5,8), (1,2), (3,1), (6,8), (11,1), (1,8), (12,1), (15,0), (3,1), (101,0), (16,1), (3,3), (4,3), (3,4), (3,8), (2,9), (7,1), (5,7), (3,1), (5,3), (3,1), (12,3), (2,3), (1,5), (14,1), (2,8), (5,6), (5,3), (6,6), (4,3), (8,6), (10,3), (1,6), (7,3), (5,1), (2,3), (6,6), (5,6), (5,6), (8,6), (14,1), (20,3), (12,1), (4,3), (5,1), (3,3), (6,1), (2,3), (3,1), (8,3), (2,1), (2,6), (6,7), (12,9), (5,1), (3,9), (4,1), (3,9), (3,1), (4,9), (4,1), (9,3), (15,1), (15,3), (121,1), (13,3), (4,4), (30,1), (13,3), (16,1), (3,1), (51,1), (10,3), (1,1), (2,1), (9,1), (4,1), (15,1), (8,3), (37,1), (10,3), (10,1), (5,9), (3,1), (2,6), (5,6), (5,3), (6,1), (10,6), (5,6), (1,3), (4,1), (2,6), (7,3), (4,1), (11,6), (1,7), (2,9), (10,1), (8,9), (31,4), (9,3), (4,1), (2,9), (4,1), (4,9), (13,1), (8,3), (3,3), (12,3), (5,1), (3,3), (18,1), (1,6), (4,8), (4,1), (9,1), (3,1), (20,8), (7,8), (2,8), (5,6), (2,7), (1,9), (13,1), (6,6), (4,7), (10,9), (5,1), (5,4), (6,4), (3,9), (4,1), (5,9), (5,1), (3,9), (4,1), (1,9), (12,1), (8,3), (3,1), (11,3), (7,4), (18,1), (5,8), (9,6), (2,6), (2,7), (7,1), (5,9), (4,7), (2,9), (11,1), (9,6), (1,7), (8,9), (2,1), (6,3), (30,3), (2,4), (7,5), (1,4), (3,1), (6,1), (9,6), (4,7), (7,6), (8,8), (2,1), (3,1), (2,8), (5,6), (1,6), (8,1), (21,6), (11,1), (148,0)]

d6 = ((5,0),d)
     where d = rleDecode [(16, 0), (7, 8), (12, 9), (71, 8), (7, 1), (3, 17), (25, 1), (6, 65), (1, 1), (60, 33), (90, 65), (52, 64), (2, 96), (3, 36), (9, 32), (5, 0), (1, 8), (37, 0), (2, 1), (2, 65), (5, 1), (2, 33), (3, 1), (2, 33), (4, 1), (1, 33), (3, 9), (1, 1), (1, 9), (4, 1), (4, 65), (4, 81), (22, 65), (21, 64), (1, 68), (2, 4), (1, 36), (5, 32), (8, 0), (4, 32), (2, 0), (13, 16), (66, 48), (2, 32), (33, 33), (2, 41), (1, 72), (17, 64), (3, 80), (31, 64), (3, 68), (1, 64), (2, 72), (3, 8), (1, 9), (11, 33), (2, 9), (2, 1), (3, 33), (6, 1), (1, 33), (1, 41), (4, 9), (8, 1), (3, 9), (1, 1), (3, 9), (3, 1), (1, 9), (3, 1), (1, 9), (4, 1), (5, 33), (2, 1), (2, 17), (4, 1), (2, 17), (13, 1), (6, 65), (1, 73), (5, 9), (5, 33), (2, 1), (2, 33), (1, 41), (1, 9), (1, 41), (4, 33), (2, 41), (3, 9), (1, 1), (1, 9), (1, 1), (6, 0), (1, 32), (4, 33), (4, 8), (2, 0), (1, 32), (1, 33), (2, 1), (1, 0), (2, 32), (1, 16), (1, 48), (11, 16), (7, 80), (2, 16), (2, 1), (8, 0), (5, 64), (9, 72), (18, 64), (17, 16), (1, 0), (8, 1), (2, 17), (20, 1), (25, 33), (1, 40), (20, 8), (31, 72), (1, 65), (10, 1), (34, 33), (1, 1), (9, 17), (11, 16), (10, 80), (2, 64), (4, 80), (2, 81), (4, 80), (2, 81), (6, 80), (7, 64), (6, 80), (1, 113), (2, 33), (2, 32), (22, 33), (2, 1), (4, 65), (7, 73), (2, 72), (4, 8), (2, 40), (4, 41), (1, 40), (8, 32), (9, 40), (2, 41), (1, 9), (19, 8), (3, 9), (3, 1), (2, 17), (1, 81), (3, 65), (7, 81), (3, 80), (26, 16), (3, 80), (1, 64), (2, 65), (1, 64), (3, 72), (2, 73), (1, 65), (1, 64), (1, 80), (4, 81), (1, 80), (1, 81), (3, 17), (4, 16), (1, 65), (2, 1), (2, 0), (14, 64), (3, 72), (25, 8), (14, 40), (2, 41), (2, 40), (2, 41), (2, 40), (3, 41), (1, 33), (14, 32), (4, 0), (4, 16), (5, 0), (2, 8), (7, 0), (3, 64), (1, 72), (3, 8), (2, 72), (8, 64), (5, 80), (6, 64), (4, 0), (4, 36), (1, 8), (3, 0), (11, 1), (3, 33), (3, 49), (3, 17), (2, 81), (25, 17), (13, 16), (1, 17), (13, 1), (2, 33), (5, 32), (1, 40), (2, 8), (1, 0), (30, 8), (1, 9), (4, 41), (4, 33), (4, 1), (1, 9), (4, 1), (1, 9), (2, 1), (2, 9), (3, 1), (2, 9), (1, 1), (1, 9), (5, 1), (2, 9), (6, 65), (1, 81), (8, 65), (5, 1), (3, 33), (1, 1), (3, 65), (5, 1), (7, 17), (1, 49), (4, 48), (2, 16), (12, 17), (5, 81), (9, 17), (3, 81), (5, 65), (3, 81), (3, 17), (10, 1), (9, 65), (8, 1), (19, 33), (4, 41), (20, 9), (5, 73), (3, 77), (1, 13), (13, 9), (4, 1), (1, 9), (4, 1), (1, 9), (7, 1), (4, 3), (10, 1), (10, 65), (38, 1), (2, 65), (69, 1), (12, 65), (4, 67), (1, 3), (62, 1), (6, 3), (20, 1), (7, 33), (5, 1), (9, 33), (1, 1), (8, 65), (10, 1), (3, 3), (1, 67), (1, 65), (4, 1), (2, 65), (7, 1), (3, 3), (9, 1), (14, 33), (1, 35), (2, 3), (12, 1), (2, 33), (4, 1), (4, 3), (4, 1), (3, 33), (2, 1), (4, 3), (2, 1), (7, 17), (1, 49), (15, 33), (3, 41), (5, 9), (1, 1), (2, 33), (5, 35), (1, 33), (7, 1), (1, 33), (8, 1), (5, 3), (3, 1), (8, 65), (6, 1), (6, 3), (1, 67), (4, 65), (3, 1), (1, 33), (5, 49), (2, 17), (4, 81), (1, 65), (1, 67), (3, 3), (3, 1), (3, 65), (2, 81), (2, 17), (1, 81), (2, 17), (3, 81), (3, 1), (13, 65), (4, 81), (12, 17), (4, 1), (3, 17), (2, 1), (5, 33), (3, 1), (12, 9), (4, 1), (6, 9), (9, 1), (3, 3), (31, 1), (4, 33), (7, 41), (20, 33), (3, 35), (2, 3), (3, 9), (2, 1), (1, 9), (7, 73), (15, 65), (1, 81), (19, 17), (5, 1), (5, 17), (2, 1), (4, 17), (2, 49), (4, 51), (1, 19), (2, 17), (16, 1), (1, 33), (19, 1), (30, 9), (32, 1), (20, 17),(170, 1), (4, 17), (3, 1), (3, 65), (1, 73), (4, 9), (8, 41), (6, 1), (2, 9), (6, 1), (1, 65), (6, 81), (14, 17), (13, 1), (9, 65), (7, 73), (3, 1), (1, 65), (13, 73), (9, 65), (4, 1), (6, 17), (4, 65), (10, 1), (2, 9), (3, 1), (4, 9), (9, 1), (2, 9), (15, 1), (1, 17), (7, 1), (3, 33), (2, 49), (27, 33), (6, 35), (3, 41), (21, 9), (1, 41), (1, 35), (3, 51), (2, 49), (5, 17), (15, 49), (3, 51), (1, 49), (1, 17), (12, 1), (7, 33), (1, 1), (2, 17), (18, 1), (13, 65), (30, 73), (1, 65), (73, 1), (2, 9), (47, 1), (31, 17), (2, 1), (2, 33), (5, 49), (1, 33), (4, 1), (3, 3), (1, 67), (2, 65), (1, 1), (3, 9), (2, 73), (9, 65), (3, 1), (20, 65), (1, 73), (4, 9), (1, 11), (3, 43), (1, 35), (4, 33), (15, 9), (2, 41), (2, 43), (1, 35), (8, 33), (2, 41), (6, 9), (3, 1), (1, 9), (1, 1), (9, 3), (10, 35), (1, 3), (1, 1), (5, 33), (2, 49), (3, 1), (2, 17), (1, 19), (3, 83), (7, 81), (4, 65), (6, 1), (1, 67), (3, 3), (14, 65), (1, 17), (1, 19), (3, 3), (4, 1), (5, 65), (1, 81), (2, 17), (6, 1), (7, 33), (1, 41), (1, 9), (11, 11), (4, 3), (1, 11), (2, 3), (1, 11), (19, 3), (14, 35), (7, 33), (2, 49), (13, 33), (3, 35), (2, 3), (2, 1), (1, 9), (5, 65), (8, 1), (2, 65), (1, 67), (3, 3), (3, 67), (18, 65), (1, 1), (3, 3), (2, 35), (1, 3), (2, 1), (8, 33), (4, 49), (1, 17), (4, 1), (2, 33), (1, 1), (2, 33), (5, 1), (2, 33), (7, 1), (8, 17), (6, 49), (1, 17), (3, 19), (2, 3), (1, 35), (1, 3), (1, 1), (9, 65), (13, 81), (1, 19), (1, 3), (2, 35), (1, 33), (7, 41), (12, 33), (8, 49), (8, 17), (1, 19), (4, 3), (3, 1), (4, 3), (2, 1), (5, 9), (1, 1), (4, 33), (3, 17), (1, 81), (3, 65), (2, 1), (2, 9), (2, 1), (6, 65), (2, 73), (10, 65), (17, 73), (1, 75), (1, 11), (7, 3), (1, 65), (3, 73), (1, 75), (2, 11), (2, 3), (2, 33), (3, 1), (2, 65), (1, 73), (1, 9), (1, 73), (3, 65), (1, 33), (4, 35), (5, 33), (4, 41), (3, 9), (1, 33), (3, 35), (4, 3), (2, 11), (1, 3), (1, 1), (2, 33), (1, 35), (4, 3), (6, 35), (2, 33), (1, 49), (5, 1), (2, 17), (2, 19), (5, 83), (3, 81), (5, 65), (6, 81), (1, 65), (1, 1), (1, 3), (2, 19), (2, 3), (4, 1), (1, 9), (1, 11), (2, 75), (2, 11), (1, 3), (3, 1), (12, 33), (4, 35), (1, 43), (10, 9), (2, 1), (1, 65), (3, 73), (2, 65), (3, 1), (12, 65), (3, 73), (3, 1), (1, 9), (1, 1), (1, 9), (9, 1), (5, 33), (1, 5), (1, 21), (2, 5), (2, 1), (2, 65), (9, 67), (2, 81), (4, 17), (6, 81), (10, 17), (3, 3), (2, 1), (8, 33), (1, 41), (10, 9), (12, 73), (9, 65), (1, 73), (3, 1), (2, 9), (8, 1), (3, 65), (4, 1), (2, 65), (7, 1), (1, 65), (4, 1), (4, 33), (4, 1), (6, 33), (3, 1), (2, 33), (37, 1), (2, 33), (39, 1), (1, 33), (16, 1), (2, 33), (3, 3), (13, 1), (2, 3), (2, 35), (10, 1), (5, 35), (5, 33), (8, 49), (5, 17), (4, 49), (4, 17), (1, 1), (1, 3), (4, 19), (14, 17), (2, 19), (4, 3), (6, 1), (4, 3), (2, 1), (3, 33), (11, 1), (1, 9), (3, 1), (2, 9), (3, 1), (26, 65), (7, 73), (5, 75), (2, 9), (5, 1), (2, 9), (3, 1), (13, 9), (1, 41), (1, 43), (1, 11), (3, 3), (2, 11), (2, 3), (1, 11), (2, 3), (1, 11), (3, 3), (1, 11), (6, 3), (1, 11), (7, 3), (1, 11), (5, 3), (21, 35), (1, 1), (10, 65), (4, 81), (13, 17), (13, 49), (6, 51), (4, 49), (1, 33), (26, 1), (6, 3), (7, 1), (2, 9), (9, 73), (1, 65), (6, 1), (2, 65), (1, 9), (9, 1), (6, 3), (15, 1), (16, 33), (1, 97), (17, 65), (3, 1), (9, 3), (3, 1), (2, 65), (9, 1), (2, 65), (4, 1), (1, 65), (1, 67), (6, 3), (7, 1), (3, 65), (1, 1), (6, 3), (4, 1), (1, 65), (5, 1), (1, 67), (3, 3), (4, 1), (4, 3), (6, 1), (5, 33), (1, 49), (1, 17), (7, 1), (5, 3), (5, 1), (2, 65), (2, 1), (1, 3), (1, 35), (1, 33), (1, 49), (1, 17), (6, 1), (1, 65), (1, 67), (3, 3), (8, 1), (7, 33), (14, 1), (4, 3), (12, 1), (1, 65), (6, 1), (4, 65), (5, 1), (1, 65), (2, 1), (7, 65), (5, 1), (1, 65), (2, 1), (7, 65), (4, 1), (1, 9), (2, 1), (21, 33), (1, 1), (13, 65), (5, 67), (1, 75), (1, 73), (3, 1), (12, 17), (4, 1), (2, 17), (1, 1), (6, 65), (2, 1), (1, 33), (6, 49), (22, 33), (2, 1), (3, 33), (1, 1), (2, 33), (9, 1), (1, 9), (5, 1), (4, 3), (2, 33), (14, 1), (3, 3), (3, 1), (4, 65), (3, 1), (2, 65), (2, 1), (15, 65), (3, 73), (4, 1), (2, 65), (9, 1), (2, 65), (3, 1), (2, 17), (2, 1), (3, 65), (14, 1), (1, 9), (5, 1), (3, 3), (5, 1), (1, 33), (5, 1), (4, 65), (8, 1), (2, 65), (1, 1), (1, 65), (3, 1), (3, 65), (12, 1), (4, 3), (1, 1), (2, 33), (7, 1), (1, 17), (5, 1), (1, 33), (8, 1), (1, 65), (3, 1), (1, 65), (2, 1), (2, 65), (5, 1), (2, 9), (7, 1), (4, 33), (2, 1), (3, 33), (5, 49), (4, 33), (3, 35), (4, 33), (5, 1), (2, 65), (2, 1), (4, 65), (1, 1), (2, 65), (2, 1), (1, 3), (2, 67), (2, 3), (1, 65), (4, 1), (2, 65), (4, 1), (1, 9), (9, 1), (1, 9), (3, 1), (1, 9), (2, 1), (3, 3), (5, 1), (5, 3), (1, 67), (4, 1), (5, 3), (11, 1), (4, 3), (2, 1), (7, 65), (1, 1), (8, 33), (1, 43), (4, 3), (3, 1), (2, 33), (3, 1), (1, 33), (4, 1), (1, 33), (2, 1), (2, 65), (9, 1), (1, 65), (13, 1), (3, 33), (1, 1), (16, 33), (5, 35), (3, 49), (1, 33), (11, 1), (3, 33), (3, 49), (4, 33), (4, 1), (4, 65), (7, 1), (3, 3), (12, 1), (1, 65), (2, 73), (2, 1), (5, 9), (7, 1), (1, 65), (7, 1), (2, 65), (6, 1), (1, 17), (10, 1), (2, 17), (4, 1), (2, 19), (2, 3), (3, 33), (2, 35), (7, 33), (4, 3), (4, 1), (2, 33), (1, 35), (4, 3), (24, 65), (2, 67), (3, 3), (10, 1), (4, 3), (2, 35), (5, 33), (1, 1), (5, 33), (2, 41), (15, 33), (1, 49), (3, 51), (5, 33), (3, 1), (2, 33), (8, 1), (11, 33), (1, 41), (1, 9), (3, 1), (6, 73), (1, 65), (4, 1), (3, 65), (3, 1), (2, 65), (5, 1), (4, 3), (1, 65), (2, 1), (1, 65), (5, 1), (2, 65), (31, 1), (1, 33), (1, 35), (3, 3), (10, 1), (1, 17), (7, 1), (2, 33), (3, 3), (9, 1), (1, 17), (3, 3), (4, 17), (4, 1), (6, 65), (5, 67), (12, 65), (15, 73), (6, 65), (4, 1), (1, 3), (1, 67), (4, 3), (1, 1), (4, 65), (2, 9), (2, 1), (1, 9), (1, 73), (1, 75), (1, 11), (2, 3), (1, 11), (1, 9), (2, 1), (1, 9), (3, 11), (3, 9), (2, 11), (4, 1), (3, 3), (1, 1), (1, 33), (1, 9), (3, 11), (3, 41), (2, 43), (2, 1), (3, 9), (2, 11), (2, 9), (2, 1), (2, 11), (1, 3), (3, 1), (4, 35), (3, 33), (2, 1), (2, 3), (1, 1), (13, 65), (1, 1), (6, 65), (11, 1), (164, 0)]

dieIn5 = ((5,1),d)
         where d = rleDecode [(50,8), (5,9), (19,8), (3,9), (1,8), (1,0), (11,32), (2,48), (1,16), (2,0), (4,72), (16,64), (13,68), (1,76), (6,77), (1,73), (3,9), (29,1), (8,33), (3,49), (1,33), (2,17), (6,1), (4,65), (1,80), (57,16), (26,17), (5,49), (4,33), (2,49), (13,33), (9,1), (17,33), (4,1), (2,9), (4,1), (20,65), (2,73), (26,65), (3,81), (5,65), (1,97), (1,33), (3,37), (1,33), (1,1), (2,65), (2,73), (3,9), (2,11), (1,9), (2,11), (30,9), (10,41), (14,9), (22,41), (4,9), (4,41), (6,33), (3,1), (4,9), (10,1), (3,65), (8,1), (2,33), (7,49), (5,33), (1,41), (2,9), (12,1), (5,9), (7,1), (5,65), (3,81), (51,65), (14,1), (5,3), (24,1), (45,17), (7,1), (2,17), (5,1), (4,3), (4,1), (3,33), (3,1), (1,33), (7,1), (3,33), (2,1), (2,33), (3,1), (2,33), (5,35), (4,33), (4,1), (5,3), (4,1), (14,33), (7,41), (13,33), (9,41), (5,33), (4,41), (6,33), (1,41), (5,43), (3,41), (1,33), (4,41), (6,33), (14,41), (4,9), (13,41), (1,35), (3,43), (4,3), (3,35), (2,3), (2,35), (1,51), (1,19), (4,3), (1,19), (5,3), (1,19), (8,3), (5,19), (2,3), (3,1), (8,17), (3,81), (19,65), (1,73), (3,65), (9,73), (2,65), (5,73), (3,65), (5,67), (1,65), (1,81), (3,73), (7,65), (7,81), (4,17), (1,3), (2,17), (1,1), (5,17), (1,19), (4,3), (3,17), (1,49), (5,33), (5,41), (6,33), (1,1), (4,17), (3,1), (1,17), (5,19), (5,17), (1,1), (2,65), (1,67), (3,3), (1,19), (2,17), (3,1), (3,17), (4,1), (2,17), (2,1), (5,19), (1,17), (1,1), (1,33), (8,41), (10,33), (1,3), (2,19), (2,83), (5,81), (7,1), (3,17), (3,19), (2,3), (7,1), (3,65), (2,1), (1,17), (6,1), (2,9), (3,1), (1,33), (1,49), (8,17), (3,81), (2,83), (4,3), (8,1), (11,9), (6,1), (2,65), (2,73), (2,65), (5,73), (1,9), (3,1), (8,9), (1,41), (1,43), (1,35), (4,43), (3,33), (5,41), (2,9), (4,1), (4,9), (1,73), (9,65), (5,73), (10,65), (21,81), (13,65), (20,81), (3,17), (2,1), (13,17), (1,1), (13,33), (8,41), (13,9), (3,1), (2,9), (1,41), (2,33), (14,32), (18,0), (5,48), (22,32), (10,40), (17,41), (2,40), (5,41), (14,33), (3,41), (1,9), (2,1), (4,17), (4,81), (14,65), (7,81), (4,65), (1,81), (4,85), (19,81), (14,17), (9,1), (4,9), (1,1), (1,81), (1,80), (26,64), (12,72), (12,64), (7,72), (1,8), (7,0), (1,8), (5,0), (1,8), (3,0), (3,8), (2,0), (1,8), (6,0), (57,32), (10,48), (1,49), (1,33), (2,32), (3,41), (5,40), (3,8), (5,9), (2,8), (2,41), (1,33), (1,32), (2,33), (2,41), (3,1), (1,16), (2,49), (1,48), (1,49), (1,17), (3,16), (1,17), (2,16), (5,0), (7,32), (3,0), (2,16), (10,0), (3,8), (6,0), (43,64), (11,72), (2,64), (7,0), (3,64), (4,80), (6,64), (30,0), (6,64), (2,0), (3,16), (8,0), (3,32), (4,0), (6,32), (2,48), (12,32), (22,40), (2,41), (3,40), (1,41), (1,40), (2,41), (2,40), (1,41), (1,40), (1,32), (1,33), (1,32), (3,41), (1,40), (2,41), (1,40), (2,0), (12,16), (1,80), (2,64), (3,72), (15,64), (1,96), (10,32), (11,48), (4,16), (15,48), (9,32), (8,0), (1,8), (2,64), (1,0), (4,16), (6,48), (2,16), (1,17), (5,16), (2,17), (2,0), (2,1), (1,17), (1,1), (4,0), (3,16), (3,0), (2,16), (4,0), (3,8), (2,72), (11,8), (10,72), (4,74), (4,72), (1,8), (9,9), (15,73), (7,75), (7,73), (1,65), (11,1), (4,33), (1,1), (2,3), (3,35), (3,1), (1,33), (2,35), (4,3), (2,33), (1,17), (8,1), (21,65), (5,67), (7,1), (2,17), (17,49), (9,33), (1,49), (1,51), (3,35), (2,33), (2,41), (4,9), (2,41), (10,9), (1,1), (1,33), (5,35), (4,33), (2,1), (1,3), (4,35), (2,33), (5,1), (3,65), (1,1), (6,3), (6,17), (9,49), (1,33), (1,1), (9,65), (5,81), (5,17), (2,19), (2,67), (1,83), (7,81), (2,65), (1,1), (9,17), (1,81), (4,65), (3,19), (5,17), (5,49), (10,17), (1,49), (1,33), (2,1), (1,33), (11,1), (1,65), (7,1), (1,9), (2,1), (3,9), (3,1), (2,33), (4,49), (9,33), (2,1), (25,65), (8,73), (20,9), (1,1), (4,35), (4,33), (2,41), (18,9), (1,41), (8,33), (2,9), (1,1), (1,33), (2,35), (1,3), (2,1), (2,33), (3,1), (6,33), (6,49), (1,17), (5,65), (1,81), (4,17), (2,81), (1,65), (3,1), (5,17), (6,49), (1,17), (5,65), (5,73), (6,65), (1,73), (10,9), (22,73), (7,65), (6,1), (1,9), (5,1), (2,17), (14,81), (17,17), (3,81), (3,65), (4,73), (3,77), (2,70), (8,81), (1,83), (3,19), (9,17), (7,1), (4,65), (5,1), (3,33), (1,1), (15,9), (5,41), (3,9), (3,41), (1,43), (3,35), (6,33), (2,41), (19,9), (2,1), (23,33), (8,1), (2,17), (4,1), (1,33), (1,1), (2,9), (2,1), (1,9), (1,1), (5,65), (4,73), (3,65), (7,1), (9,65), (2,1), (7,65), (30,1), (145,0)]

shieldAttack = ((1,0),d)
               where d = rleDecode [(30,0), (31,1), (5,33), (21,1), (4,17), (50,1), (5,5), (118,1), (7,17), (63,1), (37,65), (5,1), (10,33), (5,37), (5,33), (20,1), (3,33), (15,1), (3,33), (14,1), (3,33), (7,1), (5,17), (15,1), (15,65), (7,1), (9,33), (9,1), (3,5), (52,1), (3,33), (10,1), (4,33), (11,1), (2,33), (35,1), (5,17), (5,1), (3,17), (23,1), (9,65), (4,1), (4,17), (9,1), (6,33), (12,9), (6,41), (2,9), (6,1), (3,9), (5,1), (4,9), (4,1), (5,9), (24,1), (4,9), (15,1), (22,17), (4,1), (10,17), (16,1), (8,33), (9,41), (3,9), (3,41), (2,33), (3,1), (2,9), (14,1), (8,65), (1,81), (4,17), (16,1), (10,9), (7,41), (1,9), (6,1), (3,9), (15,1), (4,5), (1,21), (33,17), (19,1), (3,65), (9,1), (2,65), (16,1), (4,9), (10,1), (7,9), (2,1), (7,9), (8,1), (5,33), (3,41), (2,9), (6,1), (4,5), (12,1), (6,3), (10,9), (5,41), (2,9), (11,1), (5,65), (3,81), (1,17), (6,1), (7,17), (1,1), (6,17), (1,19), (4,3), (8,1), (3,17), (5,1), (5,17), (5,1), (9,17), (30,1), (3,65), (10,1), (12,65), (3,1), (2,17), (7,1), (3,17), (16,1), (5,65), (12,1), (3,33), (2,37), (2,5), (6,1), (2,33), (9,41), (4,33), (1,1), (6,9), (3,1), (4,33), (10,41), (19,9), (8,41), (4,9), (17,1), (5,3), (7,1), (8,65), (5,73), (5,1), (7,17), (14,49), (2,1), (12,65), (8,81), (5,83), (1,19), (1,83), (6,81), (10,17), (3,1), (8,33), (2,41), (21,9), (6,73), (8,9), (3,41), (1,9), (12,65), (10,81), (5,17), (3,49), (2,19), (4,3), (3,1), (10,33), (3,49), (17,17), (1,1), (4,65), (4,1), (4,3), (3,35), (4,33), (6,1), (11,17), (5,1), (6,65), (7,1), (5,3), (3,75), (4,73), (1,9), (8,1), (7,9), (3,11), (1,3), (3,35), (13,33), (3,49), (9,17), (2,3), (4,35), (3,33), (11,1), (15,9), (1,1), (8,65), (2,67), (4,83), (10,17), (5,1), (10,65), (8,17), (10,1), (3,17), (5,1), (5,33), (3,1), (13,9), (9,11), (10,1), (17,65), (2,73), (8,9), (7,33), (20,1), (6,65), (34,1), (5,3), (26,1), (11,65), (8,1), (5,3), (19,1), (7,33), (12,1), (10,33), (7,3), (30,1), (8,33), (11,1), (7,3), (4,1), (12,33), (30,1), (4,35), (2,3), (18,1), (25,65), (29,1), (10,17), (12,1), (14,17), (14,1), (6,3), (25,1), (5,17), (17,1), (6,9), (7,1), (2,9), (18,1), (6,9), (3,1), (5,33), (10,1), (3,9), (8,1), (5,33), (6,1), (5,9), (16,1), (7,33), (1,49), (10,17), (9,1), (9,17), (11,1), (3,17), (13,1), (7,65), (7,1), (3,65), (7,1), (6,65), (4,1), (15,9), (5,33), (11,1), (9,33), (4,1), (5,9), (3,1), (11,33), (8,41), (9,33), (3,41), (2,9), (6,1), (4,9), (6,33), (2,41), (12,9), (3,33), (1,1), (2,9), (8,1), (6,9), (16,1), (4,65), (6,1), (24,17), (8,16), (13,0), (2,64), (48,0), (5,4), (4,0), (2,16), (11,0), (3,8), (38,0), (13,64), (4,65), (8,1), (4,17), (5,1), (6,65), (9,1), (4,9), (16,1), (3,65), (9,1), (5,17), (5,1), (10,33), (5,9), (16,1), (8,0), (2,8), (9,0), (4,64), (7,65), (5,1), (4,3), (8,1), (4,17), (6,1), (7,0), (5,32), (9,8), (12,72), (2,64), (9,65), (7,1), (2,9), (9,1), (6,65), (14,1), (6,33), (6,1), (4,9), (12,1), (3,65), (13,1), (2,17), (15,1), (5,33), (9,1), (3,33), (3,1), (4,17), (11,1), (3,33), (6,1), (5,3), (1,1), (3,33), (13,1), (2,17), (2,19), (1,3), (11,1), (10,17), (10,1), (3,17), (7,1), (7,3), (11,1), (10,33), (2,1), (2,9), (11,73), (7,65), (1,1), (9,17), (14,1), (3,9), (1,73), (2,65), (1,73), (8,9), (6,41), (2,9), (10,1), (8,17), (5,81), (1,83), (4,67), (1,3), (9,1), (7,65), (2,81), (4,17), (6,1), (4,17), (8,1), (3,17), (3,1), (6,65), (3,1), (4,3), (8,1), (2,17), (25,1), (4,17), (7,1), (19,33), (7,41), (4,33), (1,1), (7,33), (13,1), (6,3), (30,1), (6,65), (12,1), (6,33), (3,41), (4,9), (8,1), (6,33), (3,1), (5,17), (6,3), (12,1), (3,17), (13,1), (6,17), (12,1), (7,65), (11,9), (3,1), (6,3), (1,11), (2,9), (15,1), (3,9), (6,1), (2,9), (6,1), (7,3), (18,1), (3,9), (6,1), (9,33), (1,1), (11,17), (1,81), (2,65), (3,67), (3,3), (9,1), (6,17), (3,1), (6,3), (2,19), (1,17), (14,1), (5,9), (5,1), (5,9), (2,1), (4,3), (4,35), (2,33), (6,1), (5,9), (5,1), (2,3), (5,11), (14,1), (7,3), (16,1), (10,33), (2,1), (5,17), (4,19), (3,3), (11,1), (2,9), (8,1), (6,9), (9,1), (11,65), (3,67), (3,3), (7,1), (3,17), (11,1), (2,65), (8,1), (2,17), (15,1), (5,9), (3,1), (6,65), (22,1), (7,33), (8,41), (5,1), (10,9), (11,1), (4,9), (5,1), (2,9), (12,1), (3,9), (6,1), (4,33), (3,1), (7,17), (8,1), (4,17), (1,1), (5,65), (1,81), (6,65), (9,0), (3,16), (9,17), (3,16), (4,0), (2,1), (1,17), (2,81), (6,65), (6,1), (5,17), (5,1), (5,3), (2,1), (3,65), (9,1), (4,17), (26,1), (4,3), (14,1), (4,65), (7,1), (5,65), (8,1), (3,65), (16,1), (4,65), (7,1), (6,3), (7,1), (4,65), (17,1), (4,33), (11,1), (2,33), (10,1), (3,9), (11,1), (2,9), (13,1), (3,17), (15,1), (13,33), (5,1), (3,33), (3,35), (2,3), (5,1), (3,9), (5,1), (2,65), (7,1), (16,65), (6,1), (2,65), (4,73), (1,9), (2,1), (6,3), (3,1), (3,65), (8,1), (3,9), (8,1), (4,65), (9,1), (3,65), (7,1), (2,9), (12,1), (4,3), (2,67), (1,65), (8,1), (2,9), (9,1), (4,9), (12,1), (6,3), (8,1), (3,65), (24,1), (4,3), (26,1), (4,3), (10,1), (2,65), (47,1), (142,0)]

three = ((3,0),d)
        where d = rleDecode [(16, 0), (7, 8), (12, 9), (71, 8), (7, 1), (3, 17), (25, 1), (6, 65), (1, 1), (60, 33), (90, 65), (52, 64), (2, 96), (3, 36), (9, 32), (5, 0), (1, 8), (37, 0), (2, 1), (2, 65), (5, 1), (2, 33), (3, 1), (2, 33), (4, 1), (1, 33), (3, 9), (1, 1), (1, 9), (4, 1), (4, 65), (4, 81), (22, 65), (21, 64), (1, 68), (2, 4), (1, 36), (5, 32), (8, 0), (4, 32), (2, 0), (13, 16), (66, 48), (2, 32), (33, 33), (2, 41), (1, 72), (17, 64), (3, 80), (31, 64), (3, 68), (1, 64), (2, 72), (3, 8), (1, 9), (11, 33), (2, 9), (2, 1), (3, 33), (6, 1), (1, 33), (1, 41), (4, 9), (8, 1), (3, 9), (1, 1), (3, 9), (3, 1), (1, 9), (3, 1), (1, 9), (4, 1), (5, 33), (2, 1), (2, 17), (4, 1), (2, 17), (13, 1), (6, 65), (1, 73), (5, 9), (5, 33), (2, 1), (2, 33), (1, 41), (1, 9), (1, 41), (4, 33), (2, 41), (3, 9), (1, 1), (1, 9), (1, 1), (6, 0), (1, 32), (4, 33), (4, 8), (2, 0), (1, 32), (1, 33), (2, 1), (1, 0), (2, 32), (1, 16), (1, 48), (11, 16), (7, 80), (2, 16), (2, 1), (8, 0), (5, 64), (9, 72), (18, 64), (17, 16), (1, 0), (8, 1), (2, 17), (20, 1), (25, 33), (1, 40), (20, 8), (31, 72), (1, 65), (10, 1), (34, 33), (1, 1), (9, 17), (11, 16), (10, 80), (2, 64), (4, 80), (2, 81), (4, 80), (2, 81), (6, 80), (7, 64), (6, 80), (1, 113), (2, 33), (2, 32), (22, 33), (2, 1), (4, 65), (7, 73), (2, 72), (4, 8), (2, 40), (4, 41), (1, 40), (8, 32), (9, 40), (2, 41), (1, 9), (19, 8), (3, 9), (3, 1), (2, 17), (1, 81), (3, 65), (7, 81), (3, 80), (26, 16), (3, 80), (1, 64), (2, 65), (1, 64), (3, 72), (2, 73), (1, 65), (1, 64), (1, 80), (4, 81), (1, 80), (1, 81), (3, 17), (4, 16), (1, 65), (2, 1), (2, 0), (14, 64), (3, 72), (25, 8), (14, 40), (2, 41), (2, 40), (2, 41), (2, 40), (3, 41), (1, 33), (14, 32), (4, 0), (4, 16), (5, 0), (2, 8), (7, 0), (3, 64), (1, 72), (3, 8), (2, 72), (8, 64), (5, 80), (6, 64), (4, 0), (4, 36), (1, 8), (3, 0), (11, 1), (3, 33), (3, 49), (3, 17), (2, 81), (25, 17), (13, 16), (1, 17), (13, 1), (2, 33), (5, 32), (1, 40), (2, 8), (1, 0), (30, 8), (1, 9), (4, 41), (4, 33), (4, 1), (1, 9), (4, 1), (1, 9), (2, 1), (2, 9), (3, 1), (2, 9), (1, 1), (1, 9), (5, 1), (2, 9), (6, 65), (1, 81), (8, 65), (5, 1), (3, 33), (1, 1), (3, 65), (5, 1), (7, 17), (1, 49), (4, 48), (2, 16), (12, 17), (5, 81), (9, 17), (3, 81), (5, 65), (3, 81), (3, 17), (10, 1), (9, 65), (8, 1), (19, 33), (4, 41), (20, 9), (5, 73), (3, 77), (1, 13), (13, 9), (4, 1), (1, 9), (4, 1), (1, 9), (7, 1), (4, 3), (10, 1), (10, 65), (38, 1), (2, 65), (69, 1), (12, 65), (4, 67), (1, 3), (62, 1), (6, 3), (20, 1), (7, 33), (5, 1), (9, 33), (1, 1), (8, 65), (10, 1), (3, 3), (1, 67), (1, 65), (4, 1), (2, 65), (7, 1), (3, 3), (9, 1), (14, 33), (1, 35), (2, 3), (12, 1), (2, 33), (4, 1), (4, 3), (4, 1), (3, 33), (2, 1), (4, 3), (2, 1), (7, 17), (1, 49), (15, 33), (3, 41), (5, 9), (1, 1), (2, 33), (5, 35), (1, 33), (7, 1), (1, 33), (8, 1), (5, 3), (3, 1), (8, 65), (6, 1), (6, 3), (1, 67), (4, 65), (3, 1), (1, 33), (5, 49), (2, 17), (4, 81), (1, 65), (1, 67), (3, 3), (3, 1), (3, 65), (2, 81), (2, 17), (1, 81), (2, 17), (3, 81), (3, 1), (13, 65), (4, 81), (12, 17), (4, 1), (3, 17), (2, 1), (5, 33), (3, 1), (12, 9), (4, 1), (6, 9), (9, 1), (3, 3), (31, 1), (4, 33), (7, 41), (20, 33), (3, 35), (2, 3), (3, 9), (2, 1), (1, 9), (7, 73), (15, 65), (1, 81), (19, 17), (5, 1), (5, 17), (2, 1), (4, 17), (2, 49), (4, 51), (1, 19), (2, 17), (16, 1), (1, 33), (19, 1), (30, 9), (32, 1), (20, 17),(170, 1), (4, 17), (3, 1), (3, 65), (1, 73), (4, 9), (8, 41), (6, 1), (2, 9), (6, 1), (1, 65), (6, 81), (14, 17), (13, 1), (9, 65), (7, 73), (3, 1), (1, 65), (13, 73), (9, 65), (4, 1), (6, 17), (4, 65), (10, 1), (2, 9), (3, 1), (4, 9), (9, 1), (2, 9), (15, 1), (1, 17), (7, 1), (3, 33), (2, 49), (27, 33), (6, 35), (3, 41), (21, 9), (1, 41), (1, 35), (3, 51), (2, 49), (5, 17), (15, 49), (3, 51), (1, 49), (1, 17), (12, 1), (7, 33), (1, 1), (2, 17), (18, 1), (13, 65), (30, 73), (1, 65), (73, 1), (2, 9), (47, 1), (31, 17), (2, 1), (2, 33), (5, 49), (1, 33), (4, 1), (3, 3), (1, 67), (2, 65), (1, 1), (3, 9), (2, 73), (9, 65), (3, 1), (20, 65), (1, 73), (4, 9), (1, 11), (3, 43), (1, 35), (4, 33), (15, 9), (2, 41), (2, 43), (1, 35), (8, 33), (2, 41), (6, 9), (3, 1), (1, 9), (1, 1), (9, 3), (10, 35), (1, 3), (1, 1), (5, 33), (2, 49), (3, 1), (2, 17), (1, 19), (3, 83), (7, 81), (4, 65), (6, 1), (1, 67), (3, 3), (14, 65), (1, 17), (1, 19), (3, 3), (4, 1), (5, 65), (1, 81), (2, 17), (6, 1), (7, 33), (1, 41), (1, 9), (11, 11), (4, 3), (1, 11), (2, 3), (1, 11), (19, 3), (14, 35), (7, 33), (2, 49), (13, 33), (3, 35), (2, 3), (2, 1), (1, 9), (5, 65), (8, 1), (2, 65), (1, 67), (3, 3), (3, 67), (18, 65), (1, 1), (3, 3), (2, 35), (1, 3), (2, 1), (8, 33), (4, 49), (1, 17), (4, 1), (2, 33), (1, 1), (2, 33), (5, 1), (2, 33), (7, 1), (8, 17), (6, 49), (1, 17), (3, 19), (2, 3), (1, 35), (1, 3), (1, 1), (9, 65), (13, 81), (1, 19), (1, 3), (2, 35), (1, 33), (7, 41), (12, 33), (8, 49), (8, 17), (1, 19), (4, 3), (3, 1), (4, 3), (2, 1), (5, 9), (1, 1), (4, 33), (3, 17), (1, 81), (3, 65), (2, 1), (2, 9), (2, 1), (6, 65), (2, 73), (10, 65), (17, 73), (1, 75), (1, 11), (7, 3), (1, 65), (3, 73), (1, 75), (2, 11), (2, 3), (2, 33), (3, 1), (2, 65), (1, 73), (1, 9), (1, 73), (3, 65), (1, 33), (4, 35), (5, 33), (4, 41), (3, 9), (1, 33), (3, 35), (4, 3), (2, 11), (1, 3), (1, 1), (2, 33), (1, 35), (4, 3), (6, 35), (2, 33), (1, 49), (5, 1), (2, 17), (2, 19), (5, 83), (3, 81), (5, 65), (6, 81), (1, 65), (1, 1), (1, 3), (2, 19), (2, 3), (4, 1), (1, 9), (1, 11), (2, 75), (2, 11), (1, 3), (3, 1), (12, 33), (4, 35), (1, 43), (10, 9), (2, 1), (1, 65), (3, 73), (2, 65), (3, 1), (12, 65), (3, 73), (3, 1), (1, 9), (1, 1), (1, 9), (9, 1), (5, 33), (1, 5), (1, 21), (2, 5), (2, 1), (2, 65), (9, 67), (2, 81), (4, 17), (6, 81), (10, 17), (3, 3), (2, 1), (8, 33), (1, 41), (10, 9), (12, 73), (9, 65), (1, 73), (3, 1), (2, 9), (8, 1), (3, 65), (4, 1), (2, 65), (7, 1), (1, 65), (4, 1), (4, 33), (4, 1), (6, 33), (3, 1), (2, 33), (37, 1), (2, 33), (39, 1), (1, 33), (16, 1), (2, 33), (3, 3), (13, 1), (2, 3), (2, 35), (10, 1), (5, 35), (5, 33), (8, 49), (5, 17), (4, 49), (4, 17), (1, 1), (1, 3), (4, 19), (14, 17), (2, 19), (4, 3), (6, 1), (4, 3), (2, 1), (3, 33), (11, 1), (1, 9), (3, 1), (2, 9), (3, 1), (26, 65), (7, 73), (5, 75), (2, 9), (5, 1), (2, 9), (3, 1), (13, 9), (1, 41), (1, 43), (1, 11), (3, 3), (2, 11), (2, 3), (1, 11), (2, 3), (1, 11), (3, 3), (1, 11), (6, 3), (1, 11), (7, 3), (1, 11), (5, 3), (21, 35), (1, 1), (10, 65), (4, 81), (13, 17), (13, 49), (6, 51), (4, 49), (1, 33), (26, 1), (6, 3), (7, 1), (2, 9), (9, 73), (1, 65), (6, 1), (2, 65), (1, 9), (9, 1), (6, 3), (15, 1), (16, 33), (1, 97), (17, 65), (3, 1), (9, 3), (3, 1), (2, 65), (9, 1), (2, 65), (4, 1), (1, 65), (1, 67), (6, 3), (7, 1), (3, 65), (1, 1), (6, 3), (4, 1), (1, 65), (5, 1), (1, 67), (3, 3), (4, 1), (4, 3), (6, 1), (5, 33), (1, 49), (1, 17), (7, 1), (5, 3), (5, 1), (2, 65), (2, 1), (1, 3), (1, 35), (1, 33), (1, 49), (1, 17), (6, 1), (1, 65), (1, 67), (3, 3), (8, 1), (7, 33), (14, 1), (4, 3), (12, 1), (1, 65), (6, 1), (4, 65), (5, 1), (1, 65), (2, 1), (7, 65), (5, 1), (1, 65), (2, 1), (7, 65), (4, 1), (1, 9), (2, 1), (21, 33), (1, 1), (13, 65), (5, 67), (1, 75), (1, 73), (3, 1), (12, 17), (4, 1), (2, 17), (1, 1), (6, 65), (2, 1), (1, 33), (6, 49), (22, 33), (2, 1), (3, 33), (1, 1), (2, 33), (9, 1), (1, 9), (5, 1), (4, 3), (2, 33), (14, 1), (3, 3), (3, 1), (4, 65), (3, 1), (2, 65), (2, 1), (15, 65), (3, 73), (4, 1), (2, 65), (9, 1), (2, 65), (3, 1), (2, 17), (2, 1), (3, 65), (14, 1), (1, 9), (5, 1), (3, 3), (5, 1), (1, 33), (5, 1), (4, 65), (8, 1), (2, 65), (1, 1), (1, 65), (3, 1), (3, 65), (12, 1), (4, 3), (1, 1), (2, 33), (7, 1), (1, 17), (5, 1), (1, 33), (8, 1), (1, 65), (3, 1), (1, 65), (2, 1), (2, 65), (5, 1), (2, 9), (7, 1), (4, 33), (2, 1), (3, 33), (5, 49), (4, 33), (3, 35), (4, 33), (5, 1), (2, 65), (2, 1), (4, 65), (1, 1), (2, 65), (2, 1), (1, 3), (2, 67), (2, 3), (1, 65), (4, 1), (2, 65), (4, 1), (1, 9), (9, 1), (1, 9), (3, 1), (1, 9), (2, 1), (3, 3), (5, 1), (5, 3), (1, 67), (4, 1), (5, 3), (11, 1), (4, 3), (2, 1), (7, 65), (1, 1), (8, 33), (1, 43), (4, 3), (3, 1), (2, 33), (3, 1), (1, 33), (4, 1), (1, 33), (2, 1), (2, 65), (9, 1), (1, 65), (13, 1), (3, 33), (1, 1), (16, 33), (5, 35), (3, 49), (1, 33), (11, 1), (3, 33), (3, 49), (4, 33), (4, 1), (4, 65), (7, 1), (3, 3), (12, 1), (1, 65), (2, 73), (2, 1), (5, 9), (7, 1), (1, 65), (7, 1), (2, 65), (6, 1), (1, 17), (10, 1), (2, 17), (4, 1), (2, 19), (2, 3), (3, 33), (2, 35), (7, 33), (4, 3), (4, 1), (2, 33), (1, 35), (4, 3), (24, 65), (2, 67), (3, 3), (10, 1), (4, 3), (2, 35), (5, 33), (1, 1), (5, 33), (2, 41), (15, 33), (1, 49), (3, 51), (5, 33), (3, 1), (2, 33), (8, 1), (11, 33), (1, 41), (1, 9), (3, 1), (6, 73), (1, 65), (4, 1), (3, 65), (3, 1), (2, 65), (5, 1), (4, 3), (1, 65), (2, 1), (1, 65), (5, 1), (2, 65), (31, 1), (1, 33), (1, 35), (3, 3), (10, 1), (1, 17), (7, 1), (2, 33), (3, 3), (9, 1), (1, 17), (3, 3), (4, 17), (4, 1), (6, 65), (5, 67), (12, 65), (15, 73), (6, 65), (4, 1), (1, 3), (1, 67), (4, 3), (1, 1), (4, 65), (2, 9), (2, 1), (1, 9), (1, 73), (1, 75), (1, 11), (2, 3), (1, 11), (1, 9), (2, 1), (1, 9), (3, 11), (3, 9), (2, 11), (4, 1), (3, 3), (1, 1), (1, 33), (1, 9), (3, 11), (3, 41), (2, 43), (2, 1), (3, 9), (2, 11), (2, 9), (2, 1), (2, 11), (1, 3), (3, 1), (4, 35), (3, 33), (2, 1), (2, 3), (1, 1), (13, 65), (1, 1), (6, 65), (11, 1),(164, 0)]

laserFool=((1,0),d)
           where d = rleDecode [(26, 0), (3, 1), (5, 9), (3, 8), (9, 0), (6, 8), (2, 72), (7, 64), (1, 80), (17, 16), (8, 17), (1, 49), (14, 33), (3, 41), (18, 9), (3, 73), (11, 65), (1, 1), (29, 17), (3, 49), (7, 33), (5, 41), (14, 9), (3, 1), (7, 9), (22, 1), (5, 9), (13, 1), (5, 9), (19, 1), (5, 9), (11, 1), (13, 33), (5, 41), (11, 9), (2, 1), (38, 65), (1, 81), (6, 17), (7, 21), (2, 17), (46, 49), (7, 1), (3, 17), (16, 49), (4, 17), (1, 81), (8, 65), (10, 73), (24, 65), (1, 73), (10, 65), (3, 73), (4, 9), (1, 41), (2, 33), (6, 37), (4, 33), (5, 41), (11, 9), (25, 1), (5, 33), (2, 1), (7, 9), (1, 1), (5, 33), (13, 49), (11, 17), (7, 49), (3, 17), (25, 1), (5, 65), (3, 73), (7, 65), (1, 73), (27, 65), (3, 73), (2, 9), (8, 41), (5, 9), (11, 41), (6, 33), (2, 41), (9, 9), (1, 41), (4, 33), (3, 41), (2, 9), (2, 1), (3, 33), (2, 1), (4, 73), (10, 65), (10, 73), (2, 9), (2, 41), (2, 33), (17, 49), (9, 17), (22, 49), (2, 33), (16, 1), (7, 17), (21, 65), (3, 73), (2, 9), (3, 41), (3, 33), (15, 1), (6, 73), (5, 9), (2, 1), (12, 33), (2, 1), (2, 65), (3, 69), (3, 77), (4, 73), (8, 65), (3, 81), (5, 17), (15, 16), (14, 48), (5, 49), (5, 41), (8, 40), (7, 8), (14, 72), (6, 73), (6, 72), (5, 8), (9, 40), (8, 8), (6, 40), (11, 41), (3, 33), (4, 32), (5, 16), (9, 80), (10, 81), (12, 80), (4, 81), (2, 65), (1, 81), (13, 80), (3, 16), (4, 17), (1, 81), (15, 16), (3, 48), (2, 32), (8, 33), (8, 32), (8, 40), (8, 8), (5, 40), (8, 41), (1, 9), (7, 13), (2, 45), (8, 40), (8, 8), (3, 40), (8, 41), (1, 9), (7, 73), (4, 72), (10, 64), (4, 80), (21, 16), (11, 17), (16, 16), (11, 17), (2, 25), (1, 24), (17, 8), (40, 9), (3, 41), (7, 33), (18, 65), (7, 81), (1, 85), (6, 69), (1, 73), (7, 9), (1, 41), (3, 33), (4, 35), (4, 33), (3, 49), (8, 17), (13, 81), (6, 65), (1, 1), (10, 17), (32, 49), (2, 48), (14, 16), (2, 0), (1, 64), (6, 72), (10, 8), (32, 72), (15, 8), (1, 24), (1, 56), (6, 48), (8, 0), (2, 16), (8, 0), (2, 16), (2, 48), (8, 32), (8, 0), (8, 32), (12, 40), (1, 41), (1, 33), (16, 49), (3, 17), (2, 16), (15, 0), (4, 16), (12, 0), (16, 64), (10, 72), (6, 73), (2, 89), (5, 17), (9, 49), (6, 17), (2, 81), (3, 65), (3, 73), (1, 1), (1, 3), (4, 19), (5, 17), (7, 1), (5, 17), (10, 1), (5, 33), (1, 49), (4, 17), (10, 1), (3, 65), (3, 73), (15, 9), (1, 41), (3, 43), (8, 41), (27, 9), (4, 41), (21, 1), (8, 33), (16, 1), (19, 17), (3, 19), (2, 17), (18, 65), (9, 73), (11, 9), (5, 1), (4, 9), (11, 1), (2, 9), (22, 1), (27, 33), (1, 1), (44, 65), (1, 67), (4, 3), (1, 35), (9, 33), (46, 49), (2, 17), (5, 1), (6, 33), (7, 1), (7, 65), (5, 73), (2, 9), (13, 1), (1, 65), (1, 73), (2, 9), (6, 1), (20, 65), (7, 1), (1, 3), (3, 67), (2, 19), (3, 17), (15, 1), (6, 17), (16, 1), (3, 17), (15, 1), (5, 17), (3, 1), (6, 33), (7, 41), (8, 9), (15, 41), (5, 43), (1, 3), (4, 0), (11, 64), (6, 0), (3, 32), (23, 40), (1, 9), (4, 1), (7, 0), (8, 64), (5, 80), (24, 16), (7, 0), (1, 8), (2, 0), (11, 32), (5, 0), (4, 32), (1, 40), (2, 8), (10, 0), (11, 16), (17, 17), (8, 1), (1, 0), (5, 8), (29, 72), (24, 0), (10, 1), (17, 0), (18, 1), (11, 0), (1, 32), (1, 0), (2, 16), (5, 48), (8, 32), (8, 40), (14, 41), (6, 9), (9, 41), (6, 9), (14, 1), (10, 65), (8, 1), (19, 17), (6, 21), (21, 17), (11, 81), (10, 65), (11, 73), (20, 9), (4, 1), (4, 9), (19, 1), (4, 33), (1, 35), (5, 3), (20, 1), (13, 65), (5, 81), (14, 17), (9, 49), (6, 33), (4, 41), (10, 9), (7, 73), (2, 65), (7, 1), (5, 3), (23, 1), (4, 65), (4, 81), (10, 17), (7, 49), (5, 33), (7, 41), (14, 9), (1, 73), (6, 65), (34, 73), (1, 41), (4, 33), (11, 49), (1, 17), (4, 81), (2, 65),(122, 1), (31, 65), (5, 33), (33, 49), (4, 51), (10, 49), (7, 41), (6, 73), (10, 65), (5, 81), (10, 17), (1, 33), (1, 35), (4, 43), (2, 41), (37, 9), (9, 41), (1, 33), (2, 35), (3, 43), (2, 11), (2, 3), (11, 1), (2, 33), (1, 1), (11, 65), (11, 81), (5, 83), (1, 19), (2, 3), (16, 1), (8, 65), (1, 97), (32, 33), (22, 49), (8, 51), (2, 49), (2, 33), (8, 1), (7, 9), (6, 73), (9, 65), (8, 1), (4, 9), (1, 73), (2, 65), (1, 1), (32, 17), (7, 51), (1, 43), (10, 9), (4, 8), (6, 72), (12, 73), (10, 75), (2, 11), (1, 43), (1, 41), (3, 33), (1, 32), (2, 48), (10, 16), (6, 17), (4, 19), (2, 3), (2, 65), (3, 73), (3, 65), (8, 73), (11, 9), (1, 11), (6, 35), (6, 3), (2, 1), (9, 65), (1, 81), (3, 17), (8, 19), (7, 1), (3, 65), (1, 67), (9, 3), (5, 1), (11, 65), (8, 1), (2, 3), (9, 67), (2, 3), (3, 1), (3, 33), (7, 1), (7, 33), (3, 1), (2, 33), (11, 35), (11, 33), (3, 1), (5, 33), (8, 35), (2, 3), (6, 1), (7, 33), (2, 1), (5, 65), (17, 73), (5, 9), (2, 41), (5, 33), (6, 35), (1, 33), (7, 1), (3, 9), (4, 1), (21, 33), (52, 1), (170, 0)]
